/*
ЧПП 0.5
автор lostbyte32@mail.com
ограничения - согласно j4l последней редакции, ЧПП само собой.
*/
class Animator {
    constructor(sprite, engine, animFrames = [], loop = false, speed = 300) {
        this.sprite = sprite;
        this.animFrames = [sprite];
        this.animFrames = this.animFrames.concat(animFrames);
        this.loop = loop;
        this.speed = speed;
        this.engine = engine;
        this.currentFrame = 0;
        this.updateTimer = null;
        this.animate();
    }

    animate() {
        const animator = this;


        this.updateTimer = setInterval(() => {
            animator.updateAnimation();
        }, animator.speed);

    }

    updateAnimation() {
        const animator = this;

        if (animator.currentFrame >= this.animFrames.length) {
            animator.currentFrame = 0;
            if (!this.loop) {
                clearInterval(animator.updateTimer);
                return;
            }
        }
        this.animFrames.forEach((animObject) => {
            animObject.visible = false;
        });
        this.sprite.img = this.animFrames[animator.currentFrame].getImage();
        this.sprite.img.style.top = this.pos_y + 'px';
        this.sprite.img.style.left = this.pos_x + 'px';
        this.sprite.visible = true;
        this.sprite.markUpdate();
        this.currentFrame++;
        animator.engine.updateCommonRenderer();
    }
}