/*
ЧПП 0.5
автор lostbyte32@mail.com
ограничения - согласно j4l последней редакции, ЧПП само собой.
*/
let EngineParams = { 'volume': 100, 'buffer': null };

class Sound {
    constructor(url, name, loop = false) {
        this.url = url;
        this.name = name;
        this.loop = loop;
        this.audio = new Audio(url);

        if (loop) {
            this.startLoop();
        }
        this.loop = loop;
    }

    startLoop() {
        this.loop = true;
        if (this.audio) {
            this.audio.addEventListener('ended', function () {
                this.currentTime = 0;
                this.play();
            }, false);
        }
    }

    removeLoop() {
        if (this.audio && this.loop) {
            this.audio.removeEventListener('ended');
        }
        this.loop = false;
    }

    stop() {
        this.audio.stop();
    }

    play(volume = 100) {
        volume = volume / 100;
        if (this.audio) {
            this.audio.volume = volume;
            this.audio.play();
        }
    }

}

class AudioEngine {
    constructor(gameEngine) {
        this.sounds = [];
        this.engine = gameEngine;
    }

    addSoundAsset(url, name, loop = false) {
        let sound = new Sound(url, name, loop);
        this.sounds.push(sound);
    }

    getSoundByName(name) {
        let found = null;
        this.sounds.forEach((sound) => {
            if (sound.name === name) {
                found = sound;
            }
        });
        return found;
    }

    playSoundByName(name, volume = 100) {
        let sound = this.getSoundByName(name);
        if (sound) {
            sound.play(volume);
        }
    }

    setLoopForSound(name) {
        let sound = this.getSoundByName(name);
        if (sound) {
            sound.startLoop();
        }
    }


}

class AudioMgr {
    constructor() {

    }
}