/*
ЧПП 0.5
автор lostbyte32@mail.com
ограничения - согласно j4l последней редакции, ЧПП само собой.
*/
class SceneManager {
    constructor(engine) {
        this.engine = engine;
        this.scenes = [];
    }

    addScene(scene) {
        this.scenes.push(scene);
        if (scene.isActive) {
            this.startScene(scene);
        }
    }

    createScene(name, autostart = false) {
        const newScene = new Scene(this.engine, { name: name, 'autostart': autostart });
        this.addScene(newScene);
        return newScene;
    }

    getScenes() {
        return this.scenes;
    }

    getSceneByName(name) {
        let result = null;
        this.getScenes().forEach((scene) => {
            if (scene.getName === name)
                result = scene;
        });
        return result;
    }

    updateVisibleScenes() {
        this.getScenes().forEach((scene) => {
            if (scene && scene.isActive()) {
                scene.renderObjects();
            }
        })
    }

    startScene(scene) {
    }



}