/*
ЧПП 0.5
автор lostbyte32@mail.com
ограничения - согласно j4l последней редакции, ЧПП само собой.
*/
class TexturePack {
    constructor(jsonUrl) {
        this.url = jsonUrl;
        this.path = window.location.href + jsonUrl;
        this.json = null;
    }

    loadJSONData(callback) {
        if (this.path) {
            const engine = this;
            Loader.loadJson(this.path, (err, data) => {
                if (!err) {
                    engine.json = data;
                    return (null, engine.json);
                } else
                    return (new Error('error with read json at path: ', engine.path));
            });
        }
    }

    loadImages(preloader, callback) {
        const textures = this.json.textures || this.json.frames;
        let imageSpace = null;
        let images = [];
        let files = [];
        let sourceSize = null;
        if (textures.length) {
            for (const textureData of textures) {
                imageSpace = textureData.image;
                sourceSize = { w: textureData.size.w, h: textureData.size.h };
                for (const frame of textureData.frames) {
                    files.push(frame);
                }
            }
            const imgPath = window.location.href + 'images/' + imageSpace + '.png';
            const image = preloader.preloadImage(imageSpace, imgPath, { x: 50, y: 50 }, (img) => {
                if (img && image.img.complete && files.length) {
                    for (const frame of files) {
                        let cropImage = new Img(frame.fileName, imgPath);

                        cropImage.width = frame.sourceSize.w;
                        cropImage.height = frame.sourceSize.h;
                        ImageConverter.cropImage(cropImage, frame.frame.x, frame.frame.y, frame.frame.w, frame.frame.h, 0, 0, frame.frame.w, frame.frame.h, (err, cropImage) => {
                            cropImage.name = frame.filename;
                            cropImage.nativeName = frame.fileName;
                            images.push(cropImage);
                            if (images.length === 0)
                                return (new Error('images is empty'));

                        });

                    }
                    if (images.length === files.length)
                        return (null, images);

                } else {
                    return (new Error('error with load '));
                }
            });
        } else
            return (new Error('error with load '));
    }

}