<?php

/*
 * this code under free to learn and exploration use,
 * there is covered GNU/GPL3, with j4l restrictions:
 * you can modify, but not redist as anything, what that is not cost.
 * be ready for carmic destruction.
 * there is no way to cover obfusc on it - there is big question of life, universe and something other etc.
 * you can use it on production, with all over you modifications, you can install it for any non-commercial structures,
 * or with mailing to lostbyte32@gmail.com, with words: 'we want it', and take any representable answer for "why".
 * code is free to use, learn and research.
 *
 * code redistutable as it and nobody care, for free exactly
 * j4l 0.0.2 02.11.2023
 */

namespace App;

use App\Focker;
use Cache\SimpleCache;
use Config\ConfigMgr;
use Config\DbMgr;
use Controllers\MainController;
use Files\FileWorker;
use Foundation\Installer;
use Helper\Enums;
use Helper\SystemHelper;
use Helper\TimeHelper;
use Modules\Tkach\Tkach;
use Router\RouterSystem;
use Security\BasicSecurity;
use Logger;
use \AllowDynamicProperties;

#[AllowDynamicProperties]
class Application
{
    use ConfigMgr;

    public $base_dir, $config = [], $name, $description, $dbMgr, $config_file, $router, $site_url;
    public $controller, $post, $isPostRequest = false, $system_cache = null, $client_cache = true;
    public BasicSecurity $security;
    public $url_rewrite_rules_file;
    private $crypt_key;
    public array $modules;
    public bool $is_installed = true;
    public $files = [];
    public Tkach $tkachenko;

    public AssetMgr $assetMgr;
    public Installer $installer;
    public string $upload_dir, $uploads_dir, $assets_dir, $assets_url, $assets_folder, $app_type;
    function __construct($config_file)
    {
        $this->config_file = $config_file;
        $this->base_dir = $this->get_root();
        $this->name = 'FocКtrix';
        $this->description = 'Другой способ работать с б...трюками!';
        if (!$this->url_rewrite_rules_file) {
            $this->url_rewrite_rules_file = $this->base_dir . '/config/rewrite_rules.php';
        }
        if (!empty($_POST)) {
            $this->isPostRequest = true;
            $this->post = $_POST;
        }
        if (!empty($_FILES)) {
            $this->files = $_FILES;
        }
        $this->installer = new Installer();
        $default_host = $_SERVER['HTTP_HOST'];
        $site_url = null;
        $this->is_installed = $this->installer->check_installation($this->config_file);
        $this->tkachenko = new Tkach($this->base_dir . '/assets/pics/tkach_capch.png', $this->base_dir . '/assets/fonts/oswald.ttf');
        if ($this->is_installed) {
            @require_once($this->config_file);
            @$this->config = ['host' => $host, 'port' => $port, 'pass' => $pass, 'user' => $user, 'database' => $database, 'working_dir' => $this->base_dir];
            $this->assets_dir = $this->base_dir . '/' . $assets_dir;
            $this->assets_folder = $assets_dir;
            $this->name = $app_name;
            $this->description = $app_desc;
            $this->modules = $modules;
            $this->client_cache = filter_var($use_client_cache, FILTER_VALIDATE_BOOLEAN);
            $use_server_cache = filter_var($use_server_cache, FILTER_VALIDATE_BOOLEAN);
            @$cache_store_type_update = $cache_store_type_update ? $cache_store_type_update : Enums::SC_TRIGGER_INTERVAL;
            @$cache_store_update_timer = $cache_store_update_timer ? $cache_store_update_timer : TimeHelper::ONE_MINUTE * 5;
            if (!empty($this->app_type) && $this->app_type == 'static') {
                $cache_store_update_timer = 9999999999999;
            }
            @$this->system_cache = $use_server_cache ? new SimpleCache($cache_store_type_update, $cache_store_update_timer) : false;
            if ($this->system_cache) {
                $this->system_cache->init($this);
            }

            $this->crypt_key = !empty($crypt_key) ? $crypt_key : 'AAfdyy3wr3';
            $this->app_type = (!empty($install)) ? $install : 'static';
        }

        $this->site_url = !empty($site_url) ? $site_url : $default_host;
        $this->assets_dir = !empty($assets_dir) ? $assets_dir : 'assets/';
        $this->assets_url = $site_url . '/' . $this->assets_dir;
        $this->uploads_dir = !empty($uploads_dir) ? $uploads_dir : 'uploads/';
        $this->upload_dir = $this->base_dir . '/' . $this->uploads_dir;
        @$this->dbMgr = new DbMgr($this->config);
        if ($this->dbMgr ?? $this->dbMgr->error > 0) {
            //$this->errorOnStart();
        }

        $this->security = new BasicSecurity();
        $this->controller = new MainController($this);
        $this->router = new RouterSystem($this);
        $this->assetMgr = new AssetMgr($this);
        Focker::initApp($this);
        $this->router->job();
    }
    //snipp.ru
    public static function get_ip()
    {
        $value = '';
        if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
            $value = $_SERVER['HTTP_CLIENT_IP'];
        } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
            $value = $_SERVER['HTTP_X_FORWARDED_FOR'];
        } elseif (!empty($_SERVER['REMOTE_ADDR'])) {
            $value = $_SERVER['REMOTE_ADDR'];
        }
        return $value;
    }

    public function get_crypt_key(): ?string
    {
        return $this->crypt_key;
    }

    public function get_root(): ?string
    {
        $dir = FileWorker::get_file_path($this->config_file);
        $dir = FileWorker::level_up_dir($dir);
        return $dir;
    }
    public function doRouterWork($rule): ?bool
    {
        SystemHelper::filter_requests();
        if (!empty($this->app->post)) {

            if (!$this->security::checkSecurityData($this->post['crsf_token'])) {
                return false;
            }
        }
        $action = $this->router->getActionByRule($rule);

        $this->job($action);
        return true;
    }

    public function job($action)
    {
        if ($this->controller) {
            $this->controller->doAction($action);
        }
    }
    public function errorOnStart($error = 0)
    {
        if ($this->controller) {
            //$this->controller->actionError($error);
            return;
        }
    }
    public static function getErrorMessage($error)
    {
        $message = null;
        switch ($error) {
            case 0: {
                $message = 'Default error message';
            }
                break;
            case 1: {
                $message = 'Must to populate database (Нужно заполнить базу данных MySQL)';
            }
                break;
        }
        return $message;
    }
}
