<?php
/*
this code under free to learn and exploration use,
there is covered GNU/GPL3, with j4l restrictions:
you can modify, but not redist as anything, what that is not cost.
be ready for carmic destruction.
there is no way to cover obfusc on it - there is big question of life, universe and something other etc.
you can use it on production, with all over you modifications, you can install it for any non-commercial structures,
or with mailing to lostbyte32@gmail.com, with words: 'we want it', and take any representable answer for "why".
code is free to use, learn and research.

code redistutable as it and nobody care, for free exactly
j4l 0.0.2 02.11.2023
*/
namespace App;

use Files\FileWorker;
use Helper\SystemHelper;

class AssetMgr
{
    private $_assets_dir;
    private $_js_files;
    private $_css_files;
    private $_js_files_metas = '';
    private $_css_files_metas = '';
    private $_assets = [];
    public $assets_url;
    public Application $app;
    function __construct($app)
    {
        $this->app = $app;
        $this->_assets_dir = !empty($app->assets_dir) ? $app->assets_dir : $app->base_dir . '/assets/';
        $this->assets_url = !empty($app->assets_url) ? $app->assets_url : $_SERVER['HTTP_HOST'] . '/assets/';
        $this->_js_files = [];
        $this->loadAssetsDir();

    }
    public function loadAssetsDir()
    {
        // get the all files in dir;
        $files = FileWorker::read_full_dir($this->_assets_dir);
        foreach ($files as $file) {
            $ext = FileWorker::get_file_extension_native($file);
            $file = mb_substr(explode('assets', $file)[1], 1, strlen($file));
            $asset = null;
            switch ($ext) {
                case 'js': {
                    //$file = mb_substr($sepr, 1, strlen($sepr));
                    $asset = new AssetFile($file, $ext, 0);

                    // well there is many shit more? we must now to trix priority?
                    if (strpos($file, 'Storage') !== false || strpos($file, 'Editor') !== false || strpos($file, 'enums') != false || strpos($file, 'helper.js') != false || strpos($file, 'Qrеlak.js') != false || strpos($file, 'app.js') != false) //temp hack for rewrite priority, that files is must be preferd defered
                        break;
                    $this->registerJSfile($this->_assets_dir . SystemHelper::fix_slashes($file));
                }
                    break;
                case 'css': {
                    $asset = new AssetFile($file, $ext, 0);
                    $this->registerCSSfile($this->_assets_dir . SystemHelper::fix_slashes($file));
                }
                    break;
            }
            if ($asset) {
                $this->_assets[$ext][] = $asset;
            }

        }
    }
    public function loadCustomAsset($asset_dir, $asset_name, $asset_type)
    {

    }

    public function get_scripts()
    {
        return $this->_js_files;
    }
    public function registerJScode($jscode)
    {

    }
    public function registerJSfile($jsfile)
    {
        $this->_js_files[] = $jsfile;
        $script = $this->registerJsFileSolo($jsfile);
        $this->_js_files_metas .= $this->registerJsFileSolo($jsfile);
        return $script;
    }

    public function registerCSSfile($cssfile)
    {
        $this->_css_files[] = $cssfile;
        $script = $this->registerCSSFileSolo($cssfile);
        $this->_css_files_metas .= $this->registerCSSFileSolo($cssfile);
        return $script;
    }
    public function registerCSSFileSolo($cssfile)
    {
        $cssfile = self::minify_css_file(FileWorker::read_file_as_string($cssfile));
        return sprintf('<style>%s</style>', $cssfile) . PHP_EOL;
    }

    public function registerJsFileSolo($jsfile)
    {
        $jsfile = self::minify_js_file(FileWorker::read_file_as_string($jsfile));
        return sprintf('<script type="text/javascript">%s</script>', $jsfile) . PHP_EOL;
    }

    public function registerJsFiles($jsfiles = [])
    {
        $scripts = '';
        foreach ($jsfiles as $file) {
            $scripts .= $this->registerJsFileSolo($file);
        }
        return $scripts;
    }

    public function get_metas_scripts()
    {
        return $this->_js_files_metas;
    }

    public function get_styles()
    {
        return $this->_css_files_metas;
    }

    public function registerCss($style)
    {

    }
    //echo a minified version of the $source JavaScript //stackoverflow, maxpelic
    public static function minify_js_file($content, $path = '')
    {

        $content = preg_replace("/(?:(?:\/\*(?:[^*]|(?:\*+[^*\/]))*\*+\/)|(?:(?<!\:|\\\|\'|\")\/\/.*))/", "", $content);
        $content = str_replace(array("\r\n", "\r", "\n", "\t", "  ", "    ", "    "), "", $content);

        return $content;
    }
    public static function minify_css_file($content, $path = '')
    {

        $content = preg_replace("!/\*[^*]*\*+([^/][^*]*\*+)*/!", "", $content);
        $content = str_replace(array("\r\n", "\r", "\n", "\t", "  ", "    ", "    "), "", $content);

        return $content;
    }


}