<?php
/*
this code under free to learn and exploration use,
there is covered GNU/GPL3 (as part of j4l no-care restrictions, just idea), with j4l restrictions:
you can modify, but not redist as anything, what that is not cost.
be ready for carmic destruction.
there is no way to cover obfusc on it - there is big question of life, universe and something other etc.
you can use it on production, with all over you modifications, you can install it for any non-commercial structures,
or with mailing to lostbyte32@gmail.com, with words: 'we want it', and take any representable answer for "why".
code is free to use, learn and research.

code redistutable as it and nobody care, for free exactly? with free to use, but with original link or hand-to-hand redistribution.
j4l 0.0.4 Common Annual Part Restrictions And No Cares Waranty Happens, self-licensed and as it 04.11.2023
*/
namespace Cache;

use App\RewriteRulesParser;
use Files\FileWorker;
use Helper\Enums;
use Helper\StringHelper;
use Helper\TimeHelper;

class SimpleCache
{
    //what we must have to give a cache simple work;

    //there is two tasks as now:
    // starting caching for now;
    private array $_cache_files = [];
    private string $_store_file_timer;
    public int $update_timer = TimeHelper::ONE_HOUR;
    public bool $ready_for_update = false;
    public string $block_file = '';
    public string $cache_file_name;
    public int $cache_type = Enums::SC_TRIGGER_INTERVAL;
    public string $action;
    public int $page = 0;
    private $app;

    function __construct(int $cache_type = 0, int $interval_in_minutes = 0, string $cache_file_name = "feed.php")
    {
        $this->cache_file_name = $cache_file_name;
        $this->cache_type = $cache_type;
        $this->update_timer = $interval_in_minutes;
        $this->_cache_files[] = [];

    }
    public static function serialize_data($rowdata, $pagination_data = null, $addition_content = null)
    {
        $content = ['data' => $rowdata, 'pagination' => $pagination_data, 'add' => $addition_content];
        $content = json_encode($content);
        return $content;
    }
    public static function pretty_call($action_name)
    {
        $action_name = StringHelper::lower_letters($action_name);
        return $action_name;
    }
    public static function restore_data($data)
    {
        $data = json_decode($data);
        $pagination = null;
        $addition = null;
        $rowdata = null;
        if (!empty($data->data)) {
            $rowdata = $data->data;

        }
        if (!empty($data->pagination)) {
            $pagination = (array) $data->pagination;

        }
        if (!empty($data->add)) {
            $addition = $data->add;
        }
        $content = ['data' => $rowdata, 'pagination' => $pagination, 'add' => $addition];
        return $content;
    }

    public function saveToCache($action, $page, $data = []): void
    {
        $action = self::pretty_call($action);
        $store_file = $this->app->base_dir . "/abyss/" . $action . '_' . $page . '.php';
        $cache = CacheFile::create_cache_file($store_file, $data);
        $this->_cache_files[] = $cache;
    }

    public function getFromCache($action, $page)
    {
        $action = self::pretty_call($action);
        $file = $this->getCacheByActionAndPage($action, $page);
        if (!$file)
            return null;
        $data = FileWorker::is_file($file->file_name) ? file_get_contents($file->file_name) : null;
        return $data;
    }

    public function init($app): void
    {
        $this->app = $app;
        $this->_store_file_timer = $app->base_dir . "/abyss/" . $this->cache_file_name;
        //$this->block_file = $app->base_dir . "/abyss/block.tmp";
        $this->loadCache();
        $this->createCacheTimerFile();

    }
    public function checkFileExist($file)
    {
        return FileWorker::is_file($file);
    }
    public function createCacheTimerFile($force = false)
    {
        $force = $this->isReadyForUpdate();

        if (!$this->checkFileExist($this->_store_file_timer)) {
            FileWorker::create_file($this->_store_file_timer);
        }
        if ($force) {
            FileWorker::remove_file($this->_store_file_timer);

            $this->cleanAllCache();
            FileWorker::create_file($this->_store_file_timer);
        }
        $this->ready_for_update = false;
    }
    public function createBlockFile(string $file = null): ?bool
    {
        $file = $this->_store_file_timer ? $file : "";
        $this->removeblockFile($file);
        return FileWorker::create_file($file);
    }

    public function removeBlockFile(string $file = null): ?bool
    {
        $file = $this->_store_file_timer ? $file : "";
        FileWorker::remove_file($file);
    }

    public function isBlocked(string $file = null): ?bool
    {
        $file = $file ? $this->_store_file_timer : "";
        return FileWorker::is_file($file);
    }
    public function isReadyForUpdate(): bool
    {
        $this->checkUpdate();

        return $this->ready_for_update;
    }
    public function doCacheWork()
    {
        return $this->isReadyForUpdate();
    }
    public function renderCache($action, $page)
    {
        $cache_file = $this->getCacheByActionAndPage($action, $page);
        if ($cache_file)
            include_once($cache_file->file_name);
    }
    public function getCacheByActionAndPage($action, $page = 1): ?CacheFile
    {
        $needle = null;
        if (count($this->_cache_files)) {
            foreach ($this->_cache_files as $k => $actions) {
                foreach ($actions as $file) {
                    if ($k == $action && $file->page == $page)
                        $needle = $file;
                }
            }
        }
        return $needle;
    }

    public function loadCache(): void
    {
        $path = $this->app->base_dir . "/abyss/";
        $result = FileWorker::look_over_dir($path);

        foreach ($result as $file) {
            if (strpos($file, 'action') !== false) {
                $file_string = explode('_', $file);
                $page = (int) $file_string[1];
                $cache = new CacheFile($path . $file, $page);
                $this->_cache_files[$file_string[0]][] = $cache;
            }

        }
    }
    public function createCacheFile(string $action, $page = 1, string $data = null): void
    {
        $path = $this->app->base_dir . "/abyss/" . str_replace('/', '', $action) . "_" . $page . '.php';
        if (FileWorker::is_file($path))
            FileWorker::remove_file($path);
        $file = CacheFile::create_cache_file($path, $data);
        if ($file) {
            $cache_file = new CacheFile($path, $page);
            $this->_cache_files[$action][] = $cache_file;
        }
    }

    public function cleanAllCache(): void
    {
        $update_time = $this->update_timer;
        if (!empty($this->_cache_files)) {
            foreach ($this->_cache_files as $key => $action) {
                foreach ($action as $file) {
                    if (is_object($file) && $file->creation_time + $update_time <= time()) {

                        FileWorker::remove_file($file->file_name);
                    }
                }
            }
        }
    }
    public function cleanCacheByAction($action)
    {

    }

    public function updateCachedPage($action, $page)
    {
        $url = RewriteRulesParser::getUrlByAction($action, $page);
        if (!$page || $page == 0)
            $page = '';
        $parse_url = $_SERVER['REQUEST_SCHEME'] . '://' . $_SERVER['HTTP_HOST'] . $url['url'] . $page;
        $data = file_get_contents($parse_url);
        if (!$data) {
            return null;
        }
        if (is_array($data) && empty($data['data'])) {
            return null;
        }
        $this->createCacheFile($action, $page, $data);
    }
    public function checkUpdate()
    {
        $this->ready_for_update = false;
        $time_create = FileWorker::get_file_creation_time($this->_store_file_timer);
        $update_time = $this->update_timer;
        if ($time_create + $update_time <= time()) {
            $this->ready_for_update = true;
        }
        return $this->ready_for_update;

    }
}