<?php
/*
Редакционная версия 1.
Версия лицензии 0.5.
Система модулей, в виду определённого качества и доступа - будь то парсеры, боты и прочее - 
используется для других целей - это может быть использовано в некомерческих организациях, однако уже обратно-золотно. Так как - модули - могут быть слегка не этичными. Модули свободного распространения - свободно распространяются среди коммерческих. Кроме модулей, явно предлагаемых, как продукт. Как продукт специально удовлетворяющий потребности некоммерческих организаций. Естественно - никаких регламентов не используется. Исключение - этика. Whenevere it cost, whatever it takes. 
Действующая лицензия j4l - предусматривает полное отсечение любой общей связи с GNU/GPL, в частности третьей редакции. То есть наследие, да. Остальное само собой разумеется.
Части программного обеспечения - так-же и остаются для свободного изучения, хобби,  чего угодно - что не противоречит. Главному. Здоровому интересу.
Распространяется по принципу "холодной разработки" - до момента, когда например - пример реализации хранилища версий. На решении.
Из рук-в-руки. Без третьих лиц наглых.
Код подлежит сертификации, контролю качеству и своеобразного патента код явный, авторский.
Лицензия j4l имеет алиас чпп.
j4l/ЧПП 0.5, Ежегодный внеочередной пересмотр условий лицензирования.

*/
namespace Modules\Balto;

use Files\FileWorker;
use Helper\Enums;
use Helper\SystemHelper;
use Logger\LogDebug;
use Modules\Balto\Common\Signals;
use Modules\Crawler;
use Modules\Helpfull\Telegram;
use Modules\Modules;

class Balto extends Modules
{
    const AUTHOR = "xorx";
    const MODULE_NAME = "balto";
    const DESC = "Балто - модуль FocКtrix для работы с Телеграм api(t.me/api)";

    const LICENSE = Enums::DISTRIBUTION_COM_FREE;

    private string $_api_key, $_api_url, $_last_action, $_logs_dir, $_log_file;
    public bool $webhooked = false, $standalone = false;
    public function __construct(string $api_key, bool $standalone = false, $api_url = 'https://api.telegram.org/bot')
    {
        // there is must get for initializing like hook;
        parent::__construct(Balto::AUTHOR, Balto::MODULE_NAME);
        $this->_api_key = $api_key;
        $this->_api_url = $api_url . $this->_api_key . '/';
        $this->standalone = $standalone;
        $this->_logs_dir = __DIR__ . '/breaks/';
        $this->_log_file = $this->_logs_dir . 'log.smg';
    }

    public function getLogFile()
    {
        return $this->_log_file;
    }

    public function buildMessageForSend($chat_id, $message)
    {
        $query = 'chat_id=' . $chat_id . '&text=' . $message;
        return $query;
    }

    public function getLockFile()
    {
        return $this->_logs_dir . 'lock.l';
    }

    public function getMessagesFile()
    {
        return $this->_logs_dir . 'log.smg';
    }

    public function sendHello()
    {
        return $this->sendMessage(Telegram::CHECK);
    }

    public function isWebhooker()
    {
        $this->webhooked = FileWorker::is_file($this->_logs_dir . '/lock.l');
        return $this->webhooked;
    }

    public function sendMessage(string $opcode, $to = null, $message = null, $keyboard = null, $remove = false)
    {
        //Telegram::WHOOK_SET;
        //at this moment, send just opcode, no message.
        $message = urldecode($message);
        $query_string = $this->_api_url;
        if (!$to) {
            $query_string .= $opcode;
        } else
            $query_string .= $opcode . 'disable_web_page_preview=1&chat_id=' . $to . "&text=" . $message;
        if (!$message) {

        }
        if ($keyboard) {
            $query_string .= '&reply_markup=' . $keyboard;
        }
        if ($remove) {
            $query_string .= '&reply_markup=' . json_encode(array('inline_keyboard' => [])); // . json_encode(array('remove_keyboard' => true));
        }
        return Crawler::makeApiRequest($query_string);
    }

    public function sendMessageWithData(string $opcode, $message = [])
    {
        $url = $this->_api_url;

        return Crawler::makeApiRequest($url, $message);
    }
    public function removeWebhooks(): ?string
    {
        $file = $this->getLockFile();
        $result = $this->sendMessage(Telegram::WHOOK_RM);
        $exist = FileWorker::is_file($file);
        if ($exist)
            FileWorker::remove_file($file);
        return $result;
    }

    public function initWebhooks()
    {
        $file = $this->getLockFile();
        $exist = FileWorker::is_file($file);
        $result = Signals::NO_FILE;
        $request = null;
        $webhook_caller = SystemHelper::getHostname() . SystemHelper::getRequestUri();
        if (!$exist) {
            if (FileWorker::create_file($file)) {
                $result = Signals::FILE_CREATED;
                $request = $this->sendMessage(Telegram::WHOOK_SET, $webhook_caller);

            } else
                $result = Signals::FILE_ERROR;
        } else
            $result = Signals::FILE_EXIST;

        return ['file' => $result, 'req' => $request];
    }
    public function makeKeyboard(array $buttons = []): ?string
    {
        $inline_keyboard[] = $buttons;
        $keyboard = json_encode(array('inline_keyboard' => $inline_keyboard, 'one_time_keyboard' => true));
        return $keyboard;
    }

    public function makeInlineButton($text = 'default', $url = null, $callback_data = "/test"): ?array
    {
        $button = null;
        if ($url) {
            $button = array("text" => $text, "callback_data" => $callback_data, "url" => $url);
        } else
            $button = array("text" => $text, "callback_data" => $callback_data);
        return $button;
    }

    public function awaitTransictions(string $greetings = 'Гав-гав', bool $force = false): ?array
    {
        $data = Crawler::get_input();
        $chat_id = @$data['message']['chat']['id'];
        $callback = false;
        $callback_query = @$data["callback_query"];
        if ($callback_query) {
            $chat_id = $callback_query['message']['chat']['id'];
            $callback = true;
        }
        return ['data' => $data, 'callback' => $callback, 'callback_data' => $callback_query];
    }

    public function delete_message($chat_id, $message_id)
    {
        $query_string = $this->_api_url . Telegram::DEL_MESS . "chat_id=" . $chat_id . '&message_id=' . $message_id;
        return Crawler::makeApiRequest($query_string);
    }

    public function greetings($chat_id, $message_id, $keyboard, $greetings = 'Гав-гав')
    {
        $answer = null;
        if (!$keyboard) {
            $answer = $this->sendMessage(Telegram::SEND_MESS, $chat_id, $greetings);
        } else {
            $this->delete_message($chat_id, $message_id);
            $answer = $this->sendMessage(Telegram::SEND_MESS, $chat_id, $greetings, $keyboard);
        }
    }
}