<?php
/*
Редакционная версия 1.
Версия лицензии 0.5.
Система модулей, в виду определённого качества и доступа - будь то парсеры, боты и прочее - 
используется для других целей - это может быть использовано в некомерческих организациях, однако уже обратно-золотно. Так как - модули - могут быть слегка не этичными. Модули свободного распространения - свободно распространяются среди коммерческих. Кроме модулей, явно предлагаемых, как продукт. Как продукт специально удовлетворяющий потребности некоммерческих организаций. Естественно - никаких регламентов не используется. Исключение - этика. Whenevere it cost, whatever it takes. 
Действующая лицензия j4l - предусматривает полное отсечение любой общей связи с GNU/GPL, в частности третьей редакции. То есть наследие, да. Остальное само собой разумеется.
Части программного обеспечения - так-же и остаются для свободного изучения, хобби,  чего угодно - что не противоречит. Главному. Здоровому интересу.
Распространяется по принципу "холодной разработки" - до момента, когда например - пример реализации хранилища версий. На решении.
Из рук-в-руки. Без третьих лиц наглых.
Код подлежит сертификации, контролю качеству и своеобразного патента код явный, авторский.
Лицензия j4l имеет алиас чпп.
j4l/ЧПП 0.5, Ежегодный внеочередной пересмотр условий лицензирования.

*/
namespace Modules\Pregol;

use DOMDocument;
use DOMElement;
use DOMXPath;
use Helper\SystemHelper;
use Modules\Crawler;
use Modules\Modules;
use Modules\Pregol\Branches\Left;
use Modules\Pregol\Branches\Right;


class Pregol extends Modules
{
    const AUTHOR = "xorx";
    const MODULE_NAME = "Pregol";
    const DESC = "Pregol - модуль для парсинга/грабинга страниц";
    public string $url;

    public string $query;
    public DOMDocument $dom;
    public DOMXPath $xpath;
    public Right $r_branch;
    public Left $l_branch;

    public bool $webhooked = false, $standalone = false;
    public function __construct($url)
    {
        parent::__construct(Pregol::AUTHOR, Pregol::MODULE_NAME);
        $this->url = $url;
        $this->r_branch = new Right();
        $this->l_branch = new Left;
        list($this->dom, $this->xpath) = Crawler::get_remote_page_as_dom($this->url);


    }

    public function convert_to_url_href($href): ?string
    {
        $href = $this->url . SystemHelper::pretty_url($href);
        return $href;
    }

    public function get_all_links_on_page(string $url = null)
    {
        if (empty($url))
            $url = $this->url;

        $links = $this->dom->getElementsByTagName('a');
        return $links;
    }

    public function get_first_link_on_page(string $url = null): ?array
    {
        if (empty($url))
            $url = $this->url;
        $data = (array) $this->get_all_links_on_page($url);
        $value = $data[0]->nodeValue;
        $href = $data[0]->getAttribute('href');
        return ['text' => $value, 'src' => $href];
    }

    public function build_query(string $query)
    {
        return $this->xpath->query($query);
    }

    public function build_query_array(string $query): ?array
    {
        return SystemHelper::convert_iter_to_arr($this->build_query($query));
    }

    public function get_by_id(string $id)
    {
        $this->r_branch->begin()->id($id);
        $data = $this->build_query($this->r_branch->query);
        return $data;

    }

    public function get_by_tag(string $tagName)
    {
        $this->r_branch->begin()->tag($tagName);
        $data = $this->build_query($this->r_branch->query);
        return $data;
    }

    public function get_by_class(string $className)
    {
        $this->r_branch->begin()->class($className);
        $data = $this->build_query($this->r_branch->query);
        return $data;
    }




}
