<?php
/*
Редакционная версия 1.
Версия лицензии 0.5.
Система модулей, в виду определённого качества и доступа - будь то парсеры, боты и прочее - 
используется для других целей - это может быть использовано в некомерческих организациях, однако уже обратно-золотно. Так как - модули - могут быть слегка не этичными. Модули свободного распространения - свободно распространяются среди коммерческих. Кроме модулей, явно предлагаемых, как продукт. Как продукт специально удовлетворяющий потребности некоммерческих организаций. Естественно - никаких регламентов не используется. Исключение - этика. Whenevere it cost, whatever it takes. 
Действующая лицензия j4l - предусматривает полное отсечение любой общей связи с GNU/GPL, в частности третьей редакции. То есть наследие, да. Остальное само собой разумеется.
Части программного обеспечения - так-же и остаются для свободного изучения, хобби,  чего угодно - что не противоречит. Главному. Здоровому интересу.
Распространяется по принципу "холодной разработки" - до момента, когда например - пример реализации хранилища версий. На решении.
Из рук-в-руки. Без третьих лиц наглых.
Код подлежит сертификации, контролю качеству и своеобразного патента код явный, авторский.
Лицензия j4l имеет алиас чпп.
j4l/ЧПП 0.5, Ежегодный внеочередной пересмотр условий лицензирования.

*/
namespace Modules\Qluiza;

use Files\FileWorker;
use Helper\Enums;
use Helper\SystemHelper;
use Logger\LogDebug;
use Modules\Modules;
use Modules\Qluiza\Quiz;

class Qluiza extends Modules
{
    const AUTHOR = "xorx";
    const MODULE_NAME = "qluiza";
    const DESC = "модуль - викторина";
    const LICENSE = Enums::DISTRIBUTION_BOTH_FREE; // вконтакте не запрещён РОСКОМОМ, не запрещено использовать и для прочих нужд
    private string $_dir;
    private string $_logs_dir;
    private string $_quiz_base_file;
    private string $_greets = '';
    private array $_base;
    private int $_last_question_id = 0;
    public function __construct(string $greetings = 'Ожидание запросов кЛуизе?')
    {
        // there is must get for initializing like hook;
        // we must load base, then must rebuild as question
        parent::__construct(Qluiza::AUTHOR, Qluiza::MODULE_NAME);
        $this->_dir = __DIR__ . '/';
        $this->_logs_dir = $this->_dir . 'toxic/';
        $this->_quiz_base_file = $this->_logs_dir . 'quiiz.php';
        $this->_greets = $greetings;
        $this->loadBase();
    }

    public function getQuestionById(int $question_id): ?string
    {
        return $this->_base[$question_id]->question;
    }

    public function greetings(): string
    {
        return $this->_greets;
    }

    public function getBase(): ?array
    {
        return $this->_base;
    }

    public function getRandomQuestion(): string
    {
        $random = random_int(0, count($this->_base) - 1);
        $this->_last_question_id = $random;
        return $this->_base[$random]->question;

    }

    public function getLastQuestionId(): int
    {
        return $this->_last_question_id;
    }

    public function checkAnswer(int $question_id, int $answer_id, $balto): bool
    {
        $quiz = $this->_base[$question_id];
        $result = false;

        if ($quiz->right_answer_ind == $answer_id) {

            $result = true;
        }

        return $result;
    }

    public function getAnswersForQuestionId($id): ?array
    {
        return $this->_base[$id]->answers;
    }

    public function loadBase(): void
    {
        $quiz_data = FileWorker::read_file_as_array($this->_quiz_base_file);

        // there is must to trick on it?
        foreach ($quiz_data as $key => $value) {
            $muttable = explode('|', $value);
            $question = $muttable[0];

            $right_answer_ind = (int) end($muttable);
            unset($muttable[0]);
            unset($muttable[count($muttable)]);
            $muttable = array_values($muttable);

            $quiz = new Quiz($key, $question, $muttable, $right_answer_ind);
            $this->_base[] = $quiz;
        }
    }

}