<?php
/*
Редакционная версия 1.
Версия лицензии 0.5.
Система модулей, в виду определённого качества и доступа - будь то парсеры, боты и прочее - 
используется для других целей - это может быть использовано в некомерческих организациях, однако уже обратно-золотно. Так как - модули - могут быть слегка не этичными. Модули свободного распространения - свободно распространяются среди коммерческих. Кроме модулей, явно предлагаемых, как продукт. Как продукт специально удовлетворяющий потребности некоммерческих организаций. Естественно - никаких регламентов не используется. Исключение - этика. Whenevere it cost, whatever it takes. 
Действующая лицензия j4l - предусматривает полное отсечение любой общей связи с GNU/GPL, в частности третьей редакции. То есть наследие, да. Остальное само собой разумеется.
Части программного обеспечения - так-же и остаются для свободного изучения, хобби,  чего угодно - что не противоречит. Главному. Здоровому интересу.
Распространяется по принципу "холодной разработки" - до момента, когда например - пример реализации хранилища версий. На решении.
Из рук-в-руки. Без третьих лиц наглых.
Код подлежит сертификации, контролю качеству и своеобразного патента код явный, авторский.
Лицензия j4l имеет алиас чпп.
j4l/ЧПП 0.5, Ежегодный внеочередной пересмотр условий лицензирования.

оригинальный код: https://github.com/kreativekorp/barcode
*/
namespace Modules\Qrilo\System;

class Crypton
{

    public static function dispatch_encode($data, $options)
    {
        switch (strtolower(preg_replace('/[^A-Za-z0-9]/', '', $options['s']))) {
            case 'qrl':
                return self::qr_encode($data, 0);
            case 'qrm':
                return self::qr_encode($data, 1);
            case 'qrq':
                return self::qr_encode($data, 2);
            case 'qrh':
                return self::qr_encode($data, 3);
            default:
                return self::qr_encode($data, 0);
        }
    }

    public static function qr_encode($data, $ecl)
    {
        list($mode, $vers, $ec, $data) = self::qr_encode_data($data, $ecl);
        $data = Mathmaster::qr_encode_ec($data, $ec, $vers);
        list($size, $mtx) = Mathmaster::qr_create_matrix($vers, $data);
        list($mask, $mtx) = Mathmaster::qr_apply_best_mask($mtx, $size);
        $mtx = Mathmaster::qr_finalize_matrix($mtx, $size, $ecl, $mask, $vers);
        return array(
            'q' => array(4, 4, 4, 4),
            's' => array($size, $size),
            'b' => $mtx
        );
    }

    public static function qr_encode_data($data, $ecl)
    {
        $mode = Tools::qr_detect_mode($data);
        $version = Tools::qr_detect_version($data, $mode, $ecl);
        $version_group = (($version < 10) ? 0 : (($version < 27) ? 1 : 2));
        $ec_params = Constrants::$qr_ec_params[($version - 1) * 4 + $ecl];

        /* Don't cut off mid-character if exceeding capacity. */
        $max_chars = Constrants::$qr_capacity[$version - 1][$ecl][$mode];
        if ($mode == 3)
            $max_chars <<= 1;
        $data = substr($data, 0, $max_chars);

        /* Convert from character level to bit level. */
        switch ($mode) {
            case 0:
                $code = Mathmaster::qr_encode_numeric($data, $version_group);
                break;
            case 1:
                $code = Mathmaster::qr_encode_alphanumeric($data, $version_group);
                break;
            case 2:
                $code = Mathmaster::qr_encode_binary($data, $version_group);
                break;
            case 3:
                $code = Mathmaster::qr_encode_kanji($data, $version_group);
                break;
        }

        for ($i = 0; $i < 4; $i++)
            $code[] = 0;
        while (count($code) % 8)
            $code[] = 0;

        /* Convert from bit level to byte level. */
        $data = array();
        for ($i = 0, $n = count($code); $i < $n; $i += 8) {
            $byte = 0;
            if ($code[$i + 0])
                $byte |= 0x80;
            if ($code[$i + 1])
                $byte |= 0x40;
            if ($code[$i + 2])
                $byte |= 0x20;
            if ($code[$i + 3])
                $byte |= 0x10;
            if ($code[$i + 4])
                $byte |= 0x08;
            if ($code[$i + 5])
                $byte |= 0x04;
            if ($code[$i + 6])
                $byte |= 0x02;
            if ($code[$i + 7])
                $byte |= 0x01;
            $data[] = $byte;
        }

        for ($i = count($data), $a = 1, $n = $ec_params[0]; $i < $n; $i++, $a ^= 1) {
            $data[] = $a ? 236 : 17;
        }

        /* Return. */
        return array($mode, $version, $ec_params, $data);
    }
}