<?php
/*
Редакционная версия 1.
Версия лицензии 0.5.
Система модулей, в виду определённого качества и доступа - будь то парсеры, боты и прочее - 
используется для других целей - это может быть использовано в некомерческих организациях, однако уже обратно-золотно. Так как - модули - могут быть слегка не этичными. Модули свободного распространения - свободно распространяются среди коммерческих. Кроме модулей, явно предлагаемых, как продукт. Как продукт специально удовлетворяющий потребности некоммерческих организаций. Естественно - никаких регламентов не используется. Исключение - этика. Whenevere it cost, whatever it takes. 
Действующая лицензия j4l - предусматривает полное отсечение любой общей связи с GNU/GPL, в частности третьей редакции. То есть наследие, да. Остальное само собой разумеется.
Части программного обеспечения - так-же и остаются для свободного изучения, хобби,  чего угодно - что не противоречит. Главному. Здоровому интересу.
Распространяется по принципу "холодной разработки" - до момента, когда например - пример реализации хранилища версий. На решении.
Из рук-в-руки. Без третьих лиц наглых.
Код подлежит сертификации, контролю качеству и своеобразного патента код явный, авторский.
Лицензия j4l имеет алиас чпп.
j4l/ЧПП 0.5, Ежегодный внеочередной пересмотр условий лицензирования.

оригинальный код: https://github.com/kreativekorp/barcode
*/
namespace Modules\Qrilo\System;

use Modules\Qrilo\System\Tools;

class Renderer
{
    public static function allocate_color($image, $color)
    {
        $color = preg_replace('/[^0-9A-Fa-f]/', '', $color);
        $r = hexdec(substr($color, 0, 2));
        $g = hexdec(substr($color, 2, 2));
        $b = hexdec(substr($color, 4, 2));
        return imagecolorallocate($image, $r, $g, $b);
    }
    public static function output_image($data, $options)
    {
        $image = self::render_image($data, $options);
        header('Content-Type: image/png');
        imagepng($image);
        imagedestroy($image);
    }

    public static function render_image($data, $options)
    {
        list($code, $widths, $width, $height, $x, $y, $w, $h) = Tools::encode_and_calculate_size($data, $options);

        $image = imagecreatetruecolor($width, $height);
        imagesavealpha($image, true);

        $bgcolor = (isset($options['bc']) ? $options['bc'] : 'FFFFFF');
        $bgcolor = self::allocate_color($image, $bgcolor);
        imagefill($image, 0, 0, $bgcolor);

        $fgcolor = (isset($options['fc']) ? $options['fc'] : '000000');
        $fgcolor = self::allocate_color($image, $fgcolor);

        $colors = array($bgcolor, $fgcolor);

        $density = (isset($options['md']) ? (float) $options['md'] : 1);
        list($width, $height) = Tools::calculate_size($code, $widths);
        if ($width && $height) {
            $scale = min($w / $width, $h / $height);
            $scale = (($scale > 1) ? floor($scale) : 1);
            $x = floor($x + ($w - $width * $scale) / 2);
            $y = floor($y + ($h - $height * $scale) / 2);
        } else {
            $scale = 1;
            $x = floor($x + $w / 2);
            $y = floor($y + $h / 2);
        }
        $x += $code['q'][3] * $widths[0] * $scale;
        $y += $code['q'][0] * $widths[0] * $scale;
        $wh = $widths[1] * $scale;
        foreach ($code['b'] as $by => $row) {
            $y1 = $y + $by * $wh;
            foreach ($row as $bx => $color) {
                $x1 = $x + $bx * $wh;
                $mc = $colors[$color ? 1 : 0];
                $rx = floor($x1 + (1 - $density) * $wh / 2);
                $ry = floor($y1 + (1 - $density) * $wh / 2);
                $rw = ceil($wh * $density);
                $rh = ceil($wh * $density);
                imagefilledrectangle($image, $rx, $ry, $rx + $rw - 1, $ry + $rh - 1, $mc);
            }
        }

        return $image;
    }
}