<?php
/*
Редакционная версия 1.
Версия лицензии 0.5.
Система модулей, в виду определённого качества и доступа - будь то парсеры, боты и прочее - 
используется для других целей - это может быть использовано в некомерческих организациях, однако уже обратно-золотно. Так как - модули - могут быть слегка не этичными. Модули свободного распространения - свободно распространяются среди коммерческих. Кроме модулей, явно предлагаемых, как продукт. Как продукт специально удовлетворяющий потребности некоммерческих организаций. Естественно - никаких регламентов не используется. Исключение - этика. Whenevere it cost, whatever it takes. 
Действующая лицензия j4l - предусматривает полное отсечение любой общей связи с GNU/GPL, в частности третьей редакции. То есть наследие, да. Остальное само собой разумеется.
Части программного обеспечения - так-же и остаются для свободного изучения, хобби,  чего угодно - что не противоречит. Главному. Здоровому интересу.
Распространяется по принципу "холодной разработки" - до момента, когда например - пример реализации хранилища версий. На решении.
Из рук-в-руки. Без третьих лиц наглых.
Код подлежит сертификации, контролю качеству и своеобразного патента код явный, авторский.
Лицензия j4l имеет алиас чпп.
j4l/ЧПП 0.5, Ежегодный внеочередной пересмотр условий лицензирования.

оригинальный код: https://github.com/kreativekorp/barcode
*/
namespace Modules\Qrilo\System;

class Tools
{
    public static function calculate_size($code, $widths)
    {
        $width = (
            $code['q'][3] * $widths[0] +
            $code['s'][0] * $widths[1] +
            $code['q'][1] * $widths[0]
        );
        $height = (
            $code['q'][0] * $widths[0] +
            $code['s'][1] * $widths[1] +
            $code['q'][2] * $widths[0]
        );
        return array($width, $height);
    }
    public static function qr_detect_mode($data)
    {
        $numeric = '/^[0-9]*$/';
        $alphanumeric = '/^[0-9A-Z .\/:$%*+-]*$/';
        $kanji = '/^([\x81-\x9F\xE0-\xEA][\x40-\xFC]|[\xEB][\x40-\xBF])*$/';
        if (preg_match($numeric, $data))
            return 0;
        if (preg_match($alphanumeric, $data))
            return 1;
        if (preg_match($kanji, $data))
            return 3;
        return 2;
    }

    public static function qr_detect_version($data, $mode, $ecl)
    {
        $length = strlen($data);
        if ($mode == 3)
            $length >>= 1;
        for ($v = 0; $v < 40; $v++) {
            if ($length <= Constrants::$qr_capacity[$v][$ecl][$mode]) {
                return $v + 1;
            }
        }
        return 40;
    }
    public static function encode_and_calculate_size($data, $options)
    {
        $code = Crypton::dispatch_encode($data, $options);
        $widths = array(
            (isset($options['wq']) ? (int) $options['wq'] : 1),
            (isset($options['wm']) ? (int) $options['wm'] : 1),
        );

        $size = self::calculate_size($code, $widths);
        $dscale = 4;
        $scale = (isset($options['sf']) ? (float) $options['sf'] : $dscale);
        $scalex = (isset($options['sx']) ? (float) $options['sx'] : $scale);
        $scaley = (isset($options['sy']) ? (float) $options['sy'] : $scale);
        $dpadding = 0;
        $padding = (isset($options['p']) ? (int) $options['p'] : $dpadding);
        $vert = (isset($options['pv']) ? (int) $options['pv'] : $padding);
        $horiz = (isset($options['ph']) ? (int) $options['ph'] : $padding);
        $top = (isset($options['pt']) ? (int) $options['pt'] : $vert);
        $left = (isset($options['pl']) ? (int) $options['pl'] : $horiz);
        $right = (isset($options['pr']) ? (int) $options['pr'] : $horiz);
        $bottom = (isset($options['pb']) ? (int) $options['pb'] : $vert);
        $dwidth = ceil($size[0] * $scalex) + $left + $right;
        $dheight = ceil($size[1] * $scaley) + $top + $bottom;
        $iwidth = (isset($options['w']) ? (int) $options['w'] : $dwidth);
        $iheight = (isset($options['h']) ? (int) $options['h'] : $dheight);
        $swidth = $iwidth - $left - $right;
        $sheight = $iheight - $top - $bottom;

        return array($code, $widths, $iwidth, $iheight, $left, $top, $swidth, $sheight);
    }
}