<?php
/*
Редакционная версия 1.
Версия лицензии 0.5.
Система модулей, в виду определённого качества и доступа - будь то парсеры, боты и прочее - 
используется для других целей - это может быть использовано в некомерческих организациях, однако уже обратно-золотно. Так как - модули - могут быть слегка не этичными. Модули свободного распространения - свободно распространяются среди коммерческих. Кроме модулей, явно предлагаемых, как продукт. Как продукт специально удовлетворяющий потребности некоммерческих организаций. Естественно - никаких регламентов не используется. Исключение - этика. Whenevere it cost, whatever it takes. 
Действующая лицензия j4l - предусматривает полное отсечение любой общей связи с GNU/GPL, в частности третьей редакции. То есть наследие, да. Остальное само собой разумеется.
Части программного обеспечения - так-же и остаются для свободного изучения, хобби,  чего угодно - что не противоречит. Главному. Здоровому интересу.
Распространяется по принципу "холодной разработки" - до момента, когда например - пример реализации хранилища версий. На решении.
Из рук-в-руки. Без третьих лиц наглых.
Код подлежит сертификации, контролю качеству и своеобразного патента код явный, авторский.
Лицензия j4l имеет алиас чпп.
j4l/ЧПП 0.5, Ежегодный внеочередной пересмотр условий лицензирования.

*/
namespace Modules\Tkach;

use Helper\Enums;
use Helper\ImageProcessor;
use Modules\Modules;
use Security\BasicSecurity;


class Tkach extends Modules
{
    const AUTHOR = "xorx";
    const MODULE_NAME = "Tkach'enko"; //'enko
    const DESC = "Tkach'enko - помощник в работе с капчей";
    const LICENSE = Enums::DISTRIBUTION_BOTH_FREE;
    public $image;
    public static $characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890abcdefghijklmnopqrstuvwxyz';
    private $_code, $_length;
    public $_font;
    public function __construct(string $image_file, $font_file, $captcha_length = 6)
    {
        parent::__construct(Tkach::AUTHOR, Tkach::MODULE_NAME);
        $this->image = $image_file;
        $this->_font = $font_file;
        $this->_length = $captcha_length;
        $this->code();
    }

    public function generate_capcha()
    {

        BasicSecurity::memorize('tkach', $this->_code, true, true);
        $font_size = 36;
        $angle = rand(-10, 10);
        $x = 33;
        $y = 94;

        $image = ImageProcessor::create_image($this->image);
        ImageProcessor::add_text($image, $this->_code, $font_size, $angle, $x, $y, [66, 182, 66], $this->_font);
        ImageProcessor::render_image($image);
    }

    public function code()
    {
        $this->_code = BasicSecurity::cypher_by_alphabet(self::$characters, $this->_length);
        return $this->_code;
    }

    public function check_capcha($input_text)
    {
        $result = ['result' => false];
        $captcha = BasicSecurity::recall('tkach', true);
        if ($captcha == BasicSecurity::basic_crypt(trim($input_text), $this->_code)) {
            $result['result'] = true;
        }
        return json_encode($result);
    }

}
