<?php
/*
this code under free to learn and exploration use,
there is covered GNU/GPL3, with j4l restrictions:
you can modify, but not redist as anything, what that is not cost.
be ready for carmic destruction.
there is no way to cover obfusc on it - there is big question of life, universe and something other etc.
you can use it on production, with all over you modifications, you can install it for any non-commercial structures,
or with mailing to lostbyte32@gmail.com, with words: 'we want it', and take any representable answer for "why".
code is free to use, learn and research.

code redistutable as it and nobody care, for free exactly? with free to use, but with original link or hand-to-hand redistribution.
j4l 0.0.4 Common Annual Part Restrictions And No Cares Waranty Happens, self-licensed and as it 12.12.2023
*/
namespace Widgets;

use Security\BasicSecurity;

class FormBuilder
{
    // there we must build form
    private $form_build = null;
    private $captcha;
    public function buildForm($name, $class = 'form-style-grayfox', $id = 'default', $with_checks = true, $with_captcha = false, $action_type = "POST", $encription = "text/plain", $with_custom_buttons_handler = null)
    {
        $crsf_hide = null;
        // here we must get security checks, and make hidden input with crsf key;
        $this->startFormBuilder($name, $action_type, $class, $id, $encription);
        if ($with_checks) {
            $key = BasicSecurity::getCrsfToken();
            $this->createInput('hidden', 'crsf_token', $key);
        }
        $this->captcha = $with_captcha;
    }


    public function getForm()
    {
        return $this->form_build;
    }

    public function textarea($name, $value, $options = [])
    {
        $text_area = sprintf('<textarea name="%s" id="%s">%s</textarea>', $name, $name, $value);
        $this->form_build .= PHP_EOL . $text_area;
        return $this;

    }

    public function createTextElem($name, $value = '', $placeholder = "default")
    {
        $text = sprintf('<input type="text" name="%s" value="%s" id="%s" placeholder="%s" >', $name, $value, $name, $placeholder);
        $this->form_build .= PHP_EOL . $text;
        return $this;
    }

    public function createPasswordElem($name, $value = '', $placeholder = "default")
    {
        $text = sprintf('<input type="password" name="%s" value="%s" id="%s" placeholder="%s" >', $name, $value, $name, $placeholder);
        $this->form_build .= PHP_EOL . $text;
        return $this;
    }

    public function createButton($name, $value, $onclick = null, $options = [])
    {
        $button = sprintf('<input type="button" name="%s" value="%s" id="%s" onclick="%s">', $name, $value, $name, $onclick, $name);
        $this->form_build .= PHP_EOL . $button . PHP_EOL;
        return $this;
    }

    public function createFileSave($name, $value, $multi = false, $onchange = null, $options = [])
    {
        if ($onchange && !$multi)
            $button = sprintf('<input type="file" name="%s" value="%s" id="%s" onchange="%s">', $name, $value, $name, $name, $onchange);
        if (!$onchange && !$multi)
            $button = sprintf('<input type="file" name="%s" value="%s" id="%s">', $name, $value, $name, $name);
        if ($multi) {
            $button = sprintf('<input type="file" name="%s" value="%s" id="%s" multiple="multiple">', $name, $value, $name, $name);
        }

        $this->form_build .= PHP_EOL . $button . PHP_EOL;
        return $this;
    }

    public function completeFormBuilder()
    {
        if ($this->captcha) {
            $input = '<input type="text" name="capcha" placeholder="Введите капчу">' . PHP_EOL;

            $img = $input . '<div id="capcha"><img src="/ткач"></div>' . PHP_EOL;
            $this->form_build .= $img;
        }
        $this->form_build .= '</form>' . PHP_EOL;

        return $this;
    }

    public function startFormBuilder($name, $action_type /*post/get*/ , $class = 'form-style-grayfox', $id = 'default', $encription = "text/plain")
    {
        $this->form_build = sprintf('<form action="%s" name="%s" class="%s" id="%s" enctype="%s">', $action_type, $name, $class, $id, $encription);
        return $this;
    }
    public function createSelection($name, $id, $options = [], $onchange = null)
    {
        $form = '<select>%s</select>' . PHP_EOL;
        if ($onchange) {
            $form = '<select onchange="%s">%s</select>' . PHP_EOL;
        }

        $selection = '';
        foreach ($options as $key => $option) {
            $selection .= sprintf('<option value="%s">%s</option>' . PHP_EOL, $key, $option);
        }
        if ($onchange) {
            $this->form_build .= sprintf($form, $onchange, $selection);
        } else
            $this->form_build .= sprintf($form, $selection);
        return $this;
    }

    public function createInput($type, $name, $value, $with_caption = null, $checked = null)
    {
        $checked = $checked ? 'checked' : '';
        $input = sprintf('<input type="%s" name="%s" value="%s" %s>', $type, $name, $value, $checked);
        $label = '';
        if ($with_caption)
            $label = sprintf('<label for="%s">%s</label>', $name, $with_caption);
        $this->form_build .= PHP_EOL . $input . PHP_EOL . $label;
        return $this;
    }
}