<div id="lb_visual_editor">
	<div class="toolbar">
		<button id="boldButton" title="Жирный"><b>Ж</b></button>
		<button id="italicButton" title="Курсив"><i>К</i></button>
		<button id="underlineButton" title="Подчёркнутый"><u>П</u></button>
		<button title="Зачёркнутый"><s>З</s></button>
		<button title="Верхний индекс">Верхний индекс</button>
		<button title="Нижний индекс">Нижний индекс</button>
		<button title="Маркированный список">Маркированный список</button>
		<button title="Нумерованный список">Нумерованный список</button>
		<button title="Параграф">p</button>
		<button title="Заголовок">H1</button>
		<button title="Горизонтальная линия">hr</button>
		<button title="Цитата">Цитата</button>
		<button title="Изображение" id="p-image">Изображение</button>
		<button title="Ссылка">Ссылка</button>
		<button title="Удаление ссылки">Удаление ссылки</button>
		<button title="Вставить html">HTML</button>
		<button title="Вставить текст">Text</button>
		<br>
		<button title="по левому краю">По левому</button>
		<button title="по центру">По центру</button>
		<button title="по правому краю">По правому</button>
		<button title="по ширине">По ширине</button>
		<select class="toolbar-font">
			<option selected="selected" disabled="disabled">Шрифт</option>
			<option value="arial">Arial</option>
			<option value="Courier New">Courier New</option>
			<option value="georgia">Georgia</option>
			<option value="impact">Impact</option>
			<option value="roboto">Tahoma</option>
			<option value="Times New Roman">Times New Roman</option>
			<option value="verdana">Verdana</option>
		</select>
		<select class="toolbar-size">
			<option selected="selected" disabled="disabled">Размер</option>
			<option value="1">10px</option>
			<option value="2">12px</option>
			<option value="3">14px</option>
			<option value="4">16px</option>
			<option value="5">18px</option>
			<option value="6">21px</option>
			<option value="7">26px</option>
		</select>
		<span>Цвет</span> <input class="toolbar-color" type="color" value="#ff0000" id="f-color">
		<span>Фон</span> <input class="toolbar-bg" type="color" value="#ffff00" id="b-color">
		<br>
		<button id="undoButton" title="Отмена">Отмена</button>
		<button id="redoButton" title="Повтор">Повтор</button>
		<button title="Удалить">Удалить</button>
		<button>Выделить всё</button>
		<button>Очистить стили</button>
		<button title="Вырезать">Вырезать</button>
		<button title="Копировать">Копировать</button>
	</div>

	<div class="editor" contenteditable="true">
		<p><strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</strong> Nullam molestie tellus nibh, eu
			finibus odio congue at. Nam facilisis orci non ultrices pretium. Maecenas sodales sed turpis sed vehicula.
			Duis tristique tempus mi, eget semper libero. Sed in faucibus velit. <u>Proin congue quam sed ornare
				elementum.</u> Maecenas vehicula ullamcorper mauris, ac auctor turpis viverra a. Donec bibendum auctor
			orci in maximus.</p>
		<ul>
			<li>Phasellus faucibus nisl id venenatis dignissim.</li>
			<li>Ut laoreet velit sed gravida vestibulum.</li>
			<li>Praesent et justo accumsan, pellentesque ligula sit amet, posuere justo.</li>
		</ul>
		<ol>
			<li>Integer nec ullamcorper ligula, aliquet laoreet turpis.</li>
			<li>Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas.</li>
			<li>Donec gravida a enim at tincidunt. Nulla urna erat, volutpat eget diam id, varius vulputate tortor.
			</li>
		</ol>
	</div>
	<div>

		<button onclick="test(this)" name="test">Test</button>
	</div>
</div>
<script>

	const editor = document.getElementById('editor')
	const fcolor = document.getElementById('f-color');
	const pimage = document.getElementById('p-image');
	const bcolor = document.getElementById('b-color');
	const boldButton = document.getElementById('boldButton');
	const italicButton = document.getElementById('italicButton');
	const underlineButton = document.getElementById('underlineButton');
	const undoButton = document.getElementById('undoButton');
	const redoButton = document.getElementById('redoButton');
	const plink = document.getElementById('p-link');
	if (!editor || !fcolor || !pimage || !bcolor || !boldButton || !italicButton || underlineButton || undoButton || redoButton)
		return;
	function test(t) {
		let test = editor.innerHTML;
		console.log(test);
	}
	const history = {
		back: [],
		forward: []
	};

	function performAction(command) {
		if (!history.back.length || history.back[history.back.length - 1] != editor.innerHTML) {
			history.back.push(editor.innerHTML);
		}
		document.execCommand(command, false, null);
		editor.focus();
	}

	boldButton.addEventListener('click', function () {
		performAction('bold');
	});

	italicButton.addEventListener('click', function () {
		performAction('italic');
	});

	underlineButton.addEventListener('click', function () {
		performAction('underline');
	});

	undoButton.addEventListener('click', function () {
		if (!history.back.length) {
			return;
		}
		history.forward.push(editor.innerHTML);
		editor.innerHTML = history.back.pop();
		editor.focus();
	});

	redoButton.addEventListener('click', function () {
		if (!history.forward.length) {
			return;
		} history.back.push(editor.innerHTML);
		editor.innerHTML = history.forward.pop();
		editor.focus();
	});

	editor.addEventListener('keydown', function () {
		history.forward.length = [];
		history.back.push(editor.innerHTML);
	});
	fcolor.addEventListener('click', function () {
		let val = this.value;
		document.execCommand('styleWithCSS', false, true);
		document.execCommand('foreColor', false, val);
		document.execCommand('styleWithCSS', false, false);
	});
	bcolor.addEventListener('click', function () {
		let val = this.value;
		document.execCommand('styleWithCSS', false, true);
		document.execCommand('hiliteColor', false, val);
		document.execCommand('styleWithCSS', false, false);
	});
	pimage.addEventListener('click', function () {
		var url = prompt('Введите адрес изображения', 'https://snipp.ru/demo/526/image.jpg');
		document.execCommand('insertImage', false, url);
		return false;
	});
	/*
$('body').on('click', '.toolbar-img', function(){
	var url = prompt('Введите адрес изображения', 'https://test.test/test.jpg');
	document.execCommand('insertImage', false, url);
	return false;
});
	*/
</script>